﻿Option Strict On
Imports System.Linq
Imports System.Windows.Forms
Imports System.Collections.Generic
Imports System.Xml
Imports System.Drawing.Drawing2D
Imports System.IO

Public Class Form1
    Inherits Form
    Private Path_B As String = Application.StartupPath & "\Begleitung Akkorden\"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ListView1.Items.Clear()
        ListView1.Columns.Add("Song", 120, HorizontalAlignment.Left)
        For Each File As String In System.IO.Directory.GetFiles(Path_B, "*.xml")
            ListView1.Items.Add(System.IO.Path.GetFileNameWithoutExtension(File))
        Next
    End Sub

    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        ListView2.Items.Clear()
        ListView2.View = View.Details
        'ListView2.TileSize = New Size(150, 60)
        Dim file As String = Path_B & ListView1.FocusedItem.Text & ".xml"
        Dim x As XElement = XElement.Load(file)

        Dim doc As XDocument = XDocument.Load(file)
        Dim Title As String = doc.Descendants("score-partwise").Elements("movement-title").Value
        Label1.Text = Title

        Dim getAll = x.Descendants("identification")
        For Each getLast In getAll
            Label3.Text = (getLast.Elements("creator").ElementAt(0).Value)
            'Debug.WriteLine(getLast.Elements("creator").Attributes("type").ElementAt(0).Value)
            Label2.Text = (getLast.Elements("creator").ElementAt(1).Value)
            'Debug.WriteLine(getLast.Elements("creator").Attributes("type").ElementAt(1).Value)
        Next getLast

        Dim getAllx = x.Descendants("harmony")
        For Each getValue In getAllx
            getValue.Descendants("root-alter").Value = GetChangedValueOf(getValue.Descendants("root-alter").Value)
            getValue.Descendants("degree-alter").Value = GetChangedValueOf(getValue.Descendants("degree-alter").Value)
            'getValue.Descendants("degree-value").Value = GetChangedValueOf(getValue.Descendants("degree-value").Value)
            getValue.Element("kind").Attribute("text").Value = GetChangedValueOf(getValue.Element("kind").Attribute("text").Value)

            ListView2.Items.Add(getValue.Descendants("root-step").Value & _
                                getValue.Descendants("root-alter").Value & _
                                getValue.Element("kind").Attribute("text").Value & _
                                getValue.Descendants("degree-alter").Value & _
                                getValue.Descendants("degree-value").Value)
            Label4.Text = CStr(ListView2.Items.Count)
            FLP1.Controls.Clear()
            For i As Integer = 0 To ListView2.Items.Count - 1
                Dim lb As New Label With {
                    .Name = "Label" & i.ToString,
                    .Text = ListView2.Items.Item(i).Text,
                    .Size = New Size(100, 50),
                    .BorderStyle = BorderStyle.FixedSingle,
                    .Margin = New Padding(3, 3, 3, 3),
                    .Font = New Font("Bahnschrift SemiBold SemiConden", 14),
                    .TextAlign = ContentAlignment.MiddleLeft
                    }

                FLP1.Controls.Add(lb)
            Next
        Next
        Dim Shell As New Shell32.Shell
        Dim Folder As Shell32.Folder = Shell.NameSpace(Path.GetDirectoryName(Path_B & ListView1.FocusedItem.Text & ".mp3"))
        Dim FolderItem As Shell32.FolderItem = Folder.ParseName(Path.GetFileName(Path_B & ListView1.FocusedItem.Text & ".mp3"))
        Dim s As String = (Folder.GetDetailsOf(FolderItem, 28))
        Label6.Text = "Tempo:" & (s.Substring(0, 4))
    End Sub

    Private Function GetChangedValueOf(ByVal Value As String) As String
        Select Case Value
            Case "0" : Return ""
            Case "1" : Return "#"
            Case "-1" : Return "b"
            Case "-1" : Return "b"
            Case "7" : Return "7"
            Case "m7" : Return "-7"
            Case "m6" : Return "-6"
            Case "maj7" : Return Char.ConvertFromUtf32(9651) & "7"
            Case Else : Return String.Empty
        End Select
    End Function

    Dim CurrentLabelIndex As Integer = 0
    Dim LabelCount As Integer
    Dim lb As New Label
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        LabelCount = FLP1.Controls.Count
        If LabelCount = 0 Then
            Timer1.Stop()
            Exit Sub
        End If
        FLP1.Controls("Label" & CurrentLabelIndex).BackColor = Color.FromArgb(80, Color.Yellow)
        If CurrentLabelIndex = 0 Then

            FLP1.Controls("Label" & LabelCount - 1).BackColor = SystemColors.Control
        Else
            FLP1.Controls("Label" & CurrentLabelIndex - 1).BackColor = SystemColors.Control
        End If
        CurrentLabelIndex += 1
        If CurrentLabelIndex = LabelCount Then
            CurrentLabelIndex = 0
            FLP1.Controls("Label" & CurrentLabelIndex).BackColor = SystemColors.Control
            Timer1.Stop()
        End If

    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Timer1.Interval = 500
        Timer1.Start()
    End Sub

End Class


